//Brent Cowan 100233480
//November 3 / 2007
//A factory class that both creates and stores the objects while providing a
//means to loop through them.

#include <list> 

//Factory Class
using namespace std ;

template<class T>
class Factory {
private:
	list<T> v;
	typename list<T>::iterator i; //an iterator used to loop through the objects
	typename list<T>::iterator i2;//a second iterator to manage objects
public:
	Factory();
	T* Add();
	T* GetFirst();
	T* GetNext();
	void Step();
	void Clear();
};

template<class T>
Factory<T>::Factory(){}

template<class T>
T* Factory<T>::Add()
{
	T temp;
	v.push_front(temp);
	i2 = v.begin();
	return &(*i2);
}

template<class T>
void Factory<T>::Step()//Loop through all objects
{
	for(i2=v.begin(); i2 != v.end();)
	{
		if((*i2).erase == true)//erase objects with flag set
		{
			i2 = v.erase(i2);
		}
		else
		{
			(*i2).Step(); // Do your thing!
			i2++;
		}
	}
}

template<class T>
void Factory<T>::Clear()//Delete all objects
{
	v.clear();
}

template<class T>
T* Factory<T>::GetFirst()//Get first object
{
	i = v.begin();
	if(i == v.end())return NULL;
	else return &(*i);
}

template<class T>
T* Factory<T>::GetNext()//Used for looping through the objects
{
	i++;
	if(i == v.end())return NULL;
	else return &(*i);
}