//Brent Cowan - 2011

#ifndef _Shader_
#define _Shader_


class Shader
{
private:
	char* LoadShader(char *shaderName);
	GLhandleARB glVertexShader;
	GLhandleARB glPixelShader;
	GLhandleARB shaderProgram;

public:
	Shader();
	~Shader();
	bool Load(char *vertexShader, char *pixelShader, bool debug);
	void Activate();
	void SendImage(Image* image, char* name, int imageNum);
	void SendFloat(char* name, float value);
	void SendVec4(char* name, float x, float y, float z, float w);

	static void Deactivate();
	static void Blend(int RenderMode);
};

#endif