//Brent Cowan    100233480

//this class draws a picture on the screen in 2D.
//Any scale, rotation, location, and it tiles too


#ifndef _Sprite_
#define _Sprite_

class Sprite
{
public:
	Sprite();
	Sprite(float width, float height);
	void Render();
	void SelectAnimationFrame(int rows, int columns, int frame);
	bool PointOnSprite(Vector2D point);
	Vector2D GetUV(Vector2D point);
	void CenterOrigin();
	
	float x, y;    //location of image
	float width;   //width of texture
	float height;  //height of texture
	float originX, originY; //define center of image
	float rotation;         //rotation angle
	float depth;   //for Z ordering
	float u1, u2, v1, v2;
};

#endif