#include "EngineCore.h"

//Standard libraries
#include <vector>          //standard vectors
#include <list>            //standard vectors
#include <fstream>         //Loading and saving files
using namespace std;

//Graphics
#include "Texture.h"       //abstract class for all types of textures
#include "Image.h"         //Image loading provided by DevIL
#include "Shader.h"

//2D Rendering Classes
#include "Sprite.h"
#include "Font.h"
#include "TextBox.h"
#include "Camera2D.h"

//Sound
#include "FMod/Sound.h"    //FMod wrapper