//Brent Cowan - 2011

#ifndef IMAGE_H
#define IMAGE_H

class Image : public TextureClass
{
private:
	static bool init;
	GLint  components;
	GLubyte* data;
	int width,height;
	GLuint GL_ID;
	bool keepData;
	bool clamp;

public:
	Image();
	~Image();

	bool  Load(const char *FileName);
	void  UnLoad();
	void  Activate();
	void  SetClamp(bool clamp);  //clamp texture to edge to hide seam
	void  SetKeepData(bool keep);
	float GetData(float U, float V, unsigned char component);
	float GetData(int U, int V, unsigned char component);
	int   GetWidth();
	int   GetHeight();
};

#endif